# What do other people think about this book?



When I started writing Python Machine learning, I had 3 big goals in mind:

1. Explaining the concepts well.
2. Providing the mandatory math intuition.
3. Giving practical examples to round up the learning experience and provide the tools for real-world applications.

At least, that was the plan! Whether I was successful or not ... I guess I have to leave this to you, the reader :).
I must honestly say that I was truly relieved and very happy about all the feedback to date. I am positively surprised that I haven't heard anything negative so far; I will take this as a compliment!   

<hr>

> Technical, but not too much. Let's face it, machine learning algorithms are technical in nature. However, this book allows you to gloss over the actual technical details if you don't really need to understand them right away and view the implementation of the logic in the code snippets. Though, I must say, the presentation of the technical subjects are explained clearly and with supporting graphs and images to help visualize the concepts. It was a wonderful experience to understand the code, even though the theory was also given. This allows most people to jump right in and start writing in python. For the mathematicians out there, you can take the equations and verify them if need be. [...]
The fundamental concepts I've learned have opened the door to an enormous amount of possibilities I could not have even thought of doing had I not read this book. I used to think that true machine learning was only for super geniuses. But now I feel like I have another set of tools I can use to perform nearly superhero tasks. Python Machine Learning will be a reference book I use for many years to come.   
--  Perry Nally on [Amazon](http://www.amazon.com/gp/product/1783555130/ref=s9_simh_gw_p14_d0_i2?pf_rd_m=ATVPDKIKX0DER&pf_rd_s=desktop-1&pf_rd_r=0QKDZ9QNCW8269FMDSQG&pf_rd_t=36701&pf_rd_p=2079475242&pf_rd_i=desktop)

<hr>

> Sebastian Raschka's new book, Python Machine Learning, has just been released. I got a chance to read a review copy and it's just as I expected - really great! It's well organized, super easy to follow, and it not only offers a good foundation for smart, non-experts, practitioners will get some ideas and learn new tricks here as well.  
-- Lon Riesberg, [Data Elixir Newsletter](http://dataelixir.com/issues/55#start)


<hr>

> I've purchased and read (virtually) every Machine Learning book that aims to teach the reader the basics of ML using the Scikit-learn library as the main focus. I've found them to be...less than satisfactory. The examples in other books often use ML techniques in contexts for which they are not intended to be used and/or contexts they are not used in out in the real world (among other issues I have found within them).
In stark contrast, Python Machine Learning by Sebastian Raschka is stunningly-impressive, not only for the breadth and depth of coverage, but also in the manner the information is presented to the reader. [...] One of the underlying (though understated) themes in the book is the importance of using visual aids where appropriate to gauge the performance of the algorithms you’re using as well as to understand exactly what is going on behind the scenes, so-to-speak. [...] TL;DR (SUMMARY):
I realize the experience levels described above are subjective. They are present merely to serve as reference points for the readers and to underscore my belief that Python Machine Learning has something for virtually every skill level. I cannot recommend this book more highly!   
-- Jason Wolosonovich on [Amazon](http://www.amazon.com/gp/product/1783555130/ref=s9_simh_gw_p14_d0_i2?pf_rd_m=ATVPDKIKX0DER&pf_rd_s=desktop-1&pf_rd_r=0QKDZ9QNCW8269FMDSQG&pf_rd_t=36701&pf_rd_p=2079475242&pf_rd_i=desktop)

<hr>

![](./images/feedback_1.png)

<hr>

> I just purchased your book/e-book and wanted to thank you for writing a book at this level that combines the theory with the very practical aspects of machine learning [...]. I hope to use it also as a teaching aide for some of my colleagues who work in other areas.   
-- T.S. Jayram, Researcher at the IBM Almaden CS theory group
